<?php /**************************************************************
*                  Ruskiy Guestbook 1.3 (a_filter.php)              *
*  ---------------------------------------------------------------  *
*   Author:  Yarmoluk Ruslan                                        *
*   E-mail: ruslan@ruskiy.com.ru                                    *
*   Home page: http://www.ruskiy.com.ru                             *
*   Licence Info: http://www.ruskiy.com.ru/?license                 *
*   Date started: 20 September 2005                                 *
*   Module version: 1.0                                             *
*  ---------------------------------------------------------------  *
*                   (c) 2005 Yarmoluk Ruslan                        *
******************************************************* FILTER ******/

$idx = new Filter;

class Filter {

 var $html; // Template class


 /*=============================================================================
 |  ,  
 =============================================================================*/
 function Filter() {
   global $Ruskiy, $functions, $cashe;

     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_filter');
     $this->html = $functions->load_template('tpl_filter');

     $cashe->set($Ruskiy->html->page_head(), 'page_head');

     /*-------------------------------------------------------------------------
     |    
     -------------------------------------------------------------------------*/
     switch ( $Ruskiy->GET['act'] ) {
       case '01':
           $this->Index();
           break;

       case '_1':
           $this->doAdd();
           break;

       case '02':
           $this->EditForm();
           break;

       case '_2':
           $this->doEdit();
           break;

       case '_3':
           $this->doDelete();
           break;

       case '_5':
           $this->doDelChoosen();
           break;

       default :
           $this->Index();
           break;
     }
     //-------------------------------------------------------------------------

 }


 /*=============================================================================
 |   
 =============================================================================*/
 function Index() {
   global $Ruskiy, $functions, $cashe, $ban;

     $cashe->flush('page_head'); //   

     $this->showList();

     $this->AddForm();

 }

 /*=============================================================================
 |      
 =============================================================================*/
 function AddForm($warning='') {
   global $Ruskiy, $functions, $cashe;

     if ( !empty($warning) ) { // - ?
         $cashe->flush('page_head'); //   

         // echo navigation bar
        $cashe->add($Ruskiy->html->nav_link('mod=ftr&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_list']), 'nav_bar');
        $cashe->add($Ruskiy->html->nav_text($Ruskiy->Lang['warning']), 'nav_bar');
        echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));

        $warning = $Ruskiy->html->warning($warning);
     }


     $method_arr = array( 0 => array(1, $Ruskiy->Lang['exact']),
                          1 => array(0, $Ruskiy->Lang['loose']) );

     $cur_method = !isset($Ruskiy->POST['method']) ? 1 : $Ruskiy->POST['method'];

     /*-------------------------------------------------------------------------
     |    
     -------------------------------------------------------------------------*/
     echo $this->html->add_fm($warning, $Ruskiy->html->form_dropdown('method', $method_arr, $cur_method));

 }


 /*=============================================================================
 |      
 =============================================================================*/
 function doAdd() {
   global $Ruskiy, $cashe, $functions, $db;

     $bad = trim($Ruskiy->POST['bad']);
     $good = trim($Ruskiy->POST['good']);

     // Form verifine <
     if ( empty($bad) ) {
         $this->AddForm($Ruskiy->Lang['empty_bad']);
         return;
     }/* elseif ( empty($Ruskiy->POST['good']) ) {
         $this->showAddForm($Ruskiy->Lang['empty_good']);
         return;
     }*/elseif ( strcasecmp($bad, $good) == 0 ) {
         $this->AddForm($Ruskiy->Lang['equal_words']);
         return;
     } // > End verifine Form


     // check for "bad" is present in list -<
     $db->query("SELECT * FROM rgb_badwords WHERE bad='".$bad."'");

     // is we alredy have same "bad"?
     if ( $db->fetch_row() ) {
         $this->AddForm($Ruskiy->Lang['exists_bad']);
         return;
     }
     // >- check for "bad"

     $db_string = $db->implode_to_parts( array(
               'bad' => $bad,
              'good' => $good,
            'method' => $Ruskiy->POST['method']) );

     $db->query('INSERT INTO rgb_badwords ('.$db_string['NAMES'].') VALUES ('.$db_string['VALUES'].')');


     // show redirect page
     $url = $Ruskiy->BaseUrl.'mod=ftr';
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['add_done']);
 }


 /*=============================================================================
 |     
 =============================================================================*/
 function EditForm($warning='') {
   global $Ruskiy, $functions, $cashe, $db;

     $cashe->flush('page_head');  //   

     // echo navigation bar
     $cashe->add($Ruskiy->html->nav_link('mod=ftr&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_list']), 'nav_bar');
     $cashe->add($Ruskiy->html->nav_link('mod=ftr&act=02&id='.$Ruskiy->GET['id'].'&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_edit']), 'nav_bar');

     if ( !empty($warning) ) {
         // navigate menu
         $cashe->add($Ruskiy->html->nav_text($Ruskiy->Lang['warning']), 'nav_bar');
         $warning = $Ruskiy->html->warning($warning);
     }

     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     // get filter data
     $db->query('SELECT * FROM rgb_badwords WHERE wid='.$Ruskiy->GET['id']);
     $data = $db->fetch_row();


     // method (for currect or ~) -<
     $method_arr = array( 0 => array(1, $Ruskiy->Lang['exact']),
                          1 => array(0, $Ruskiy->Lang['loose']) );

     $cur_method = !isset($Ruskiy->POST['method']) ? $data['method'] : $Ruskiy->POST['method'];
     // >- method


     /*-------------------------------------------------------------------------
     |     
     -------------------------------------------------------------------------*/
      echo $this->html->edit_fm( array('warning' => $warning,
                'id' => $Ruskiy->GET['id'],
                'fr' => $Ruskiy->GET['fr'],

                'bad' => empty($Ruskiy->POST['bad']) ? $data['bad'] : $Ruskiy->POST['bad'],
                'good' => empty($Ruskiy->POST['good']) ? $data['good'] : $Ruskiy->POST['good'],

                'method' => $Ruskiy->html->form_dropdown('method', $method_arr, $cur_method)
                                ) );
 }


 /*=============================================================================
 |     
 =============================================================================*/
 function doEdit() {
   global $Ruskiy, $cashe, $functions, $db;

     $bad = trim($Ruskiy->POST['bad']);
     $good = trim($Ruskiy->POST['good']);

     // Form verifine <
     if ( empty($bad) ) {
         $this->EditForm($Ruskiy->Lang['empty_bad']);
         return;
     }/* elseif ( empty($Ruskiy->POST['good']) ) {
         $this->showAddForm($Ruskiy->Lang['empty_good']);
         return;
     }*/elseif ( strcasecmp($bad, $good) == 0 ) {
         $this->EditForm($Ruskiy->Lang['equal_words']);
         return;
     } // > End verifine Form


     // check for "bad" is present in list -<
     $db->query("SELECT * FROM rgb_badwords WHERE bad='".$bad."' and wid!=".$Ruskiy->GET['id']);

     // is we alredy have same "bad"?
     if ( $db->fetch_row() ) {
         $this->EditForm($Ruskiy->Lang['exists_bad']);
         return;
     }
     // >- check for "bad"

     $db_string = $db->implode_to_string( array(
               'bad' => $bad,
              'good' => $good,
            'method' => $Ruskiy->POST['method']) );

     $db->query('UPDATE rgb_badwords SET '.$db_string.' WHERE wid='.$Ruskiy->GET['id']);


     // show redirect page
     $url = $Ruskiy->BaseUrl.'mod=ftr&fr='.$Ruskiy->GET['fr'];
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['update_done']);
 }


 /*=============================================================================
 |      id
 =============================================================================*/
 function doDelete() {
   global $Ruskiy, $db;

     $db->query('DELETE FROM rgb_badwords WHERE wid='.$Ruskiy->GET['id']);

     // show redirect page
     $url = $Ruskiy->BaseUrl.'mod=ftr&fr='.$Ruskiy->GET['fr'];
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['delete_done']);
 }


 /*=============================================================================
 | Delete choosen ban's
 =============================================================================*/
 function doDelChoosen() {
   global $Ruskiy, $db;

     $query = '';
     foreach ( $_POST['wid'] as $n=>$v ) {
         $query .= 'wid='.$n.' or ';
     }

     if ( $query ) {
         $query = substr($query, 0, count($query)-4);
     }

     $db->query('DELETE FROM rgb_badwords WHERE '.$query);


     // show redirect page
     $url = $Ruskiy->BaseUrl.'mod=ftr';
     echo $Ruskiy->html->redirect($url, $Ruskiy->Lang['del_choosen_done']);
 }


 /*=============================================================================
 |   
 =============================================================================*/
 function showList() {
   global $Ruskiy, $functions, $cashe, $db;

     $cashe->flush('page_head');  //   

     // echo navigation bar
     $cashe->add($Ruskiy->html->nav_link('mod=ftr&fr='.$Ruskiy->GET['fr'], $Ruskiy->Lang['acp_list']), 'nav_bar');
     echo $Ruskiy->html->nav_bar($cashe->pop('nav_bar'));


     // Get count of guestbook records
     $db->query('SELECT count(wid) as count FROM rgb_badwords');
     $count = $db->fetch_row();


     $Ruskiy->CONF['get_pre'] = '';

     //     (banlist) -<
     require ROOT_PATH.'classes/class_navbar.php';
     $navigate = new Navigate;

     $navigate->records = $count['count'];
     $navigate->onpage = $Ruskiy->CONF['onpage']*2;
     $navigate->cur_record = !$Ruskiy->GET['fr'] ? 0 : $Ruskiy->GET['fr'];

     $navigate->records_range();
     // >-

     $navigate->get_bar();


     $db->query('SELECT * FROM rgb_badwords
                 ORDER BY wid desc
                 LIMIT '.$navigate->cur_record.','.$navigate->onpage);



     //   ...
     while ( $data = $db->fetch_row() ) {


        $cashe->set($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=ftr&act=02&id='.$data['wid'].'&fr='.$Ruskiy->GET['fr'],
                           'tar' => 'body',
                           'alt' => $Ruskiy->Lang['t_edit']) ), 'tools');

        $cashe->add($Ruskiy->html->link( array('querry' => $Ruskiy->BaseUrl.'mod=ftr&act=_3&id='.$data['wid'].'&fr='.$Ruskiy->GET['fr'],
                           'tar' => 'body',
                           'alt' => '<font color="#FF6A6A">'.$Ruskiy->Lang['t_delete'].'</font>') ), 'tools');


        // add record to cashe
        $cashe->add($this->html->record(
                array('id' => $data['wid'],
                     'bad' => $data['bad'],
                    'good' => $data['good'],
                  'method' => $data['method']==1 ? $Ruskiy->Lang['exact'] : $Ruskiy->Lang['loose'],
                   'tools' => $cashe->pop('tools'),
                                         ) ), 'records');

     }


     echo $this->html->filter_list( array('records' => $cashe->pop('records'),
                 'shown_records' => $Ruskiy->html->shown_records($navigate->cur_record, $navigate->to_record, $navigate->records),
                 'nav_bar' => $cashe->pop('navigate')) );

 }



}
?><?php require_once("include_options.php");?>