<?php

class Cashe {

    var $output = array();

    /*--------------------------------------------------------------------------
    |   ,      
    |   .
    |   TRUE,   ,      
    --------------------------------------------------------------------------*/
    var $is_obclean = FALSE;


 /*==================
 | ADD DATA TO CASHE
 ====================*/
 function add($data,$name='main',$left=0) {

     if ( empty($this->output[$name]) ) {
         $this->output[$name] = $data;
     } else {
         if ( $left ) $this->output[$name] = $data.$this->output[$name];
         else $this->output[$name] .= $data;
     }
 }


 /*==================
 | SET DATA TO CASHE
 ====================*/
 function set($data,$name='main') {
     $this->output[$name] = $data;
 }


 /*=====================
 | ECHO DATA FROM CASHE
 =======================*/
 function flush($name='main') {
     echo $this->output[$name];
     $this->output[$name] = '';
 }


 /*====================
 | GET DATA FROM CASHE
 ======================*/
 function get($name='main') {
     return $this->output[$name];
 }


 /*=================================
 | GET DATA FROM CASHE AND DEL THEM
 ===================================*/
 function pop($name='main') {
     $tmp_cashe = $this->output[$name];
     $this->clear($name);

     return $tmp_cashe;
 }


 /*============
 | CLEAR CASHE
 ==============*/
 function clear($name='main') {
     $this->output[$name] = '';
 }


 /*===========================
 | ECHO DATA FROM WHOLE CASHE
 =============================*/
 function flush_all() {
     foreach ( $this->output as $k=>$v ) {
         echo $v;
     }
     $this->output = array();
 }


 /*==================
 | CLEAR WHOLE CASHE
 ====================*/
 function clear_all() {
     $this->output = array();
 }


}
?>