<?php


class Parser {

 var $emoticon_count = 0;
 var $emoticons = array();


 /*=============================================================================
 | CLEAR VALUE FROM DANGER SYMBOLS
 =============================================================================*/
 function txt_getclean($value) {
   global $Ruskiy;

     $value = trim($value);
     $value = stripslashes($value);

     //$value = preg_replace("/&(?!#[0-9]+;)/s", '&amp;', $value);

     $value = str_replace('<'   , '&lt;'  , $value);
	 $value = str_replace('>'   , '&gt;'  , $value);
	 $value = str_replace('"'   , '&quot;', $value);

     $value = str_replace("\r\n", '<br>'  , $value);
     $value = str_replace("\r"  , '<br>'  , $value);
     $value = str_replace("\n"  , '<br>'  , $value);
     $value = str_replace('$'   , '&#36;' , $value);

     $value = eregi_replace("(<br>*){2,}", '<br><br>', $value);


     //if ( !empty($Ruskiy->CONF['message']['wordwrap']) ) {
       //  $value = wordwrap($value, $Ruskiy->CONF['message']['wordwrap'], ' ', 1);
     //}
     //$value = html_entity_decode($value);

     return $value;
 }


 /*=============================================================================
 | DELETE OR EXCHANGE BAD WORDS
 =============================================================================*/
 function bad_words($text='') {
   global $db, $Ruskiy;

	 if ( $text == '' )
		 return '';

	 if ( !$Ruskiy->CONF['enable_badword'] )
		 return $text;


     $db->query('SELECT * from rgb_badwords');

	 if ( $db->get_num_rows() ) {

         while ( $data = $db->fetch_row() ) {

             $data['good'] = $data['good']=='' ? '*****' : $data['good'];

             $data['method'] = preg_quote($data['method'], "/");

			 //---------------------------

			 if ( $data['method'] == 1 ) {
			 	 $text = preg_replace("/(^|\b)".stripslashes($data['bad'])."(\b|!|\?|\.|,|$)/i", stripslashes($data['good']), $text);
			 } else {
				 $text = preg_replace("/".stripslashes($data['bad'])."/i", stripslashes($data['good']), $text);
			 }
         }

	 }

	 return $text;
 }


 /*=============================================================================
 | UNCONVERT FUNCTION
 =============================================================================*/
 function unconvert($txt='') {

	 $txt = preg_replace("#<!--emo&(.+?)-->.+?<!--endemo-->#", "\\1", $txt);


	 $txt = preg_replace("#<!--flash (.+?)-->.+?<!--endflash-->#e", "\$this->unconvert_flash('\\1')", $txt);
	 $txt = preg_replace("#<img src=[\"'](\S+?)['\"].+?".">#", "\[IMG\]\\1\[/IMG\]", $txt);

	 $txt = preg_replace("#<a href=[\"']mailto:(.+?)['\"]>(.+?)</a>#", "\[EMAIL=\\1\]\\2\[/EMAIL\]", $txt);
	 $txt = preg_replace("#<a href=[\"'](http://|https://|ftp://|news://)?(\S+?)['\"].+?".">(.+?)</a>#", "\[URL=\\1\\2\]\\3\[/URL\]", $txt);

	 $txt = preg_replace("#<i>(.+?)</i>#is", "\[i\]\\1\[/i\]", $txt);
	 $txt = preg_replace("#<b>(.+?)</b>#is", "\[b\]\\1\[/b\]", $txt);
	 $txt = preg_replace("#<s>(.+?)</s>#is", "\[s\]\\1\[/s\]", $txt);
	 $txt = preg_replace("#<u>(.+?)</u>#is", "\[u\]\\1\[/u\]", $txt);


     $txt = preg_replace("#<span style=['\"]font-size:(.+?)pt;line-height:100%['\"]>(.+?)</span>#se" , "\$this->unconvert_size('\\1', '\\2')", $txt);

	 while ( preg_match("#<span style=['\"]color:(.+?)['\"]>(.+?)</span>#is", $txt) ) {
		 $txt = preg_replace( "#<span style=['\"]color:(.+?)['\"]>(.+?)</span>#is"    , "\[color=\\1\]\\2\[/color\]", $txt);
	 }

     $txt = preg_replace("#<span style=['\"]font-family:(.+?)['\"]>(.+?)</span>#is", "\[font=\\1\]\\2\[/font\]", $txt);


     $txt = str_replace('&lt;', '<', $txt);
	 $txt = str_replace('&gt;', '>', $txt);
	 $txt = str_replace('&quot;', '"', $txt);
     $txt = str_replace('<br>', "\n", $txt);
     $txt = str_replace('&#36;', '$', $txt);
     $txt = str_replace('&#39;', "'", $txt);

	 return trim(stripslashes($txt));
 }


 function unconvert_size($size='', $text='') {
 	 $size -= 7;
	 return '[SIZE='.$size.']'.$text.'[/SIZE]';
 }


 function unconvert_flash($flash='') {
	 $arr = explode('+', $flash );
	 return '[FLASH='.$arr[0].','.$arr[1].']'.$arr[2].'[/FLASH]';
 }



 /*=============================================================================
 | CONVERT BCODES LIKE ([B],[I],[URL]...) INTO HTML ESSENCE LIKE (<b>,<i>,<a>..)
 =============================================================================*/
 function convert($txt='') {
   global $Ruskiy, $functions, $db;

	 $txt = preg_replace("/<br>|<br \/>/", "\n", $txt); // Convert <br> to \n

     $txt = preg_replace("#(^|\s)((http|https|news|ftp)://\w+[^\s\[\]]+)#ie", "\$this->regex_build_url(array('html' => '\\2', 'show' => '\\2', 'st' => '\\1'))", $txt);



	 // Do [CODE] tag
     $txt = preg_replace("#\[code\](.+?)\[/code\]#ies", "\$this->regex_code_tag('\\1')", $txt);


     // Auto parse URLs
     $txt = preg_replace("#(^|\s)((http|https|news|ftp)://\w+[^\s\[\]]+)#ie", "\$this->regex_build_url(array('html' => '\\2', 'show' => '\\2', 'st' => '\\1'))", $txt);


	 // Do [QUOTE(name,date)] tags
	 // Find the first, and last quote tag (greedy match)...
	 //$txt = preg_replace("#(\[quote(.+?)?\].*\[/quote\])#ies", "\$this->regex_parse_quotes('\\1')", $txt);



	 // Do [IMG] [FLASH] tags
	 //if ($ibforums->vars['allow_images']) {
	 $txt = preg_replace("#\[img\](.+?)\[/img\]#ie", "\$this->regex_check_image('\\1')" , $txt);
	   //	 $txt = preg_replace("#(\[flash=)(\S+?)(\,)(\S+?)(\])(\S+?)(\[\/flash\])#ie", "\$this->regex_check_flash('\\2','\\4','\\6')", $txt);
	 //}


     //  ([b], [i], [u], [/b], [/i], [/u])  (<b>, <i>, <u>, </b>, </i>, </u>)
	 $txt = preg_replace("#\[b\](.+?)\[/b\]#is", "<b>\\1</b>", $txt);
	 $txt = preg_replace("#\[i\](.+?)\[/i\]#is", "<i>\\1</i>", $txt);
	 $txt = preg_replace("#\[u\](.+?)\[/u\]#is", "<u>\\1</u>", $txt);
     $txt = preg_replace("#\[s\](.+?)\[/s\]#is", "<s>\\1</s>", $txt);


     //  ((c), (r), (tm))   (&copy;, &#153;, &reg;)
	 $txt = preg_replace("#\(c\)#i" , '&copy;', $txt);
	 $txt = preg_replace("#\(tm\)#i", '&#153;', $txt);
	 $txt = preg_replace("#\(r\)#i" , '&reg;' , $txt);


     /*-------------------------------------------------------------------------
     |  ([email]name@index.com[/email] 
     |           [email=name@index.com]Email me[/email])
     |        (<a href='mailto:name@index.com'>name@index.com</a> 
     |           <a href='mailto:name@index.com'>Email me</a>)
     -------------------------------------------------------------------------*/
     $txt = preg_replace("#\[email\](\S+?)\[/email\]#i"                                                              , "<a href='mailto:\\1' class=ruskiy_link>\\1</a>", $txt);
	 $txt = preg_replace("#\[email\s*=\s*\&quot\;([\.\w\-]+\@[\.\w\-]+\.[\.\w\-]+)\s*\&quot\;\s*\](.*?)\[\/email\]#i", "<a href='mailto:\\1' class=ruskiy_link>\\2</a>", $txt);
	 $txt = preg_replace("#\[email\s*=\s*([\.\w\-]+\@[\.\w\-]+\.[\w\-]+)\s*\](.*?)\[\/email\]#i"                     , "<a href='mailto:\\1' class=ruskiy_link>\\2</a>", $txt);


     /*-------------------------------------------------------------------------
     |  ([url]http://www.index.com[/url] 
     |           [url=http://www.index.com]My site[/url])
     |        (<a href='mailto:matt@index.com'>matt@index.com</a> 
     |           <a href='mailto:matt@index.com'>Email me</a>)
     -------------------------------------------------------------------------*/
	 $txt = preg_replace("#\[url\](\S+?)\[/url\]#ie"                                      , "\$this->regex_build_url(array('html'=>'\\1', 'show'=>'\\1'))", $txt);
	 $txt = preg_replace("#\[url\s*=\s*\&quot\;\s*(\S+?)\s*\&quot\;\s*\](.*?)\[\/url\]#ie", "\$this->regex_build_url(array('html'=>'\\1', 'show'=>'\\2'))", $txt);
	 $txt = preg_replace("#\[url\s*=\s*(\S+?)\s*\](.*?)\[\/url\]#ie"                      , "\$this->regex_build_url(array('html'=>'\\1', 'show'=>'\\2'))", $txt);


     // font size, colour and font style -<

     // [size=6]Text here[/size]
     while ( preg_match("#\[size=([^\]]+)\](.+?)\[/size\]#ies", $txt) ) {
         $txt = preg_replace("#\[size=([^\]]+)\](.+?)\[/size\]#ies", "\$this->regex_font_attr(array('s'=>'size','1'=>'\\1','2'=>'\\2'))", $txt);
	 }

     // [font=courier]Text here[/font]
	 while ( preg_match("#\[font=([^\]]+)\](.*?)\[/font\]#ies", $txt) )	{
		 $txt = preg_replace("#\[font=([^\]]+)\](.*?)\[/font\]#ies", "\$this->regex_font_attr(array('s'=>'font','1'=>'\\1','2'=>'\\2'))", $txt);
	 }

     // [color=red]Text here[/color]
	 while( preg_match("#\[color=([^\]]+)\](.+?)\[/color\]#ies", $txt) ) {
		 $txt = preg_replace( "#\[color=([^\]]+)\](.+?)\[/color\]#ies"  , "\$this->regex_font_attr(array('s'=>'col' ,'1'=>'\\1','2'=>'\\2'))", $txt);
	 }
     // >-


     $txt = preg_replace("/\n/", '<br>', $txt); // Swop \n back to <br>



     //  (:mellow:, :huh:, ^_^  ...)    -<
	 if ( $Ruskiy->CONF['enable_emote'] && $Ruskiy->POST['use_smiles'] ) {
		 $txt = ' '.$txt.' ';

         $db->query("SELECT * FROM rgb_emoticons");

         while ( $emote = $db->fetch_row() ) {

             //       . \\ + * ? [ ^ ] $ ( ) { } = ! < > | :
             $code = preg_quote($emote['code'], '/');

             $img = $emote['file'];

             $txt = preg_replace("!(?<=[^\w&;/])$code(?=.\W|\W.|\W$)!ei", "\$this->convert_emoticon('$code', '$img')", $txt);
	     }
     }
     // >-


     $txt = $this->bad_words($txt);

     return trim($txt);
 }




 /*=============================================================================
 | CONVERT EMOTEICON TO HTML IMAGE
 =============================================================================*/
 function convert_emoticon($code='', $image='') {
   global $Ruskiy;

	 if ( !$code || !$image ) return;

     $code = stripslashes($code); // Remove slashes added by preg_quote

	 $this->emoticon_count++; // count emoticon ++

     /*-------------------------------------------------------------------------
     | Return image emoticon
     -------------------------------------------------------------------------*/
	 return '<!--emo&'.trim($code).'--><img src="'.$Ruskiy->GuestUrl.'emoticons/'.$image.'" alt="'.$code.'" class=ruskiy_emoticon /><!--endemo-->';
 }


 /*=============================================================================
 | BUILD URL FROM TAG [URL=index.com]My Site[/URL]
 =============================================================================*/
 function regex_build_url($url=array()) {

     /*-------------------------------------------------------------------------
     | Make sure the last character isn't punctuation.. if it is, remove it and
     | add it to the  end array
     -------------------------------------------------------------------------*/
	 if ( preg_match("/([\.,\?]|&#33;)$/", $url['html'], $match) ) {
	  	$url['end'] .= $match[1];
	  	$url['html'] = preg_replace("/([\.,\?]|&#33;)$/", '', $url['html']);
	  	$url['show'] = preg_replace("/([\.,\?]|&#33;)$/", '', $url['show']);
	 }

	 $url['html'] = preg_replace("/&amp;/", '&', $url['html']); // Clean up the ampersands

     /*-------------------------------------------------------------------------
     | Make sure we don't have a javascript link
     -------------------------------------------------------------------------*/
	 $url['html'] = preg_replace("/javascript:/i", 'java script&#58; ', $url['html']);


     /*-------------------------------------------------------------------------
     | Do we have http:// at the front?
     -------------------------------------------------------------------------*/
	 if ( !preg_match("#^(http|news|https|ftp|aim)://#", $url['html']) ) {
			$url['html'] = 'http://'.$url['html'];
	 }


     /*-------------------------------------------------------------------------
     | Tidy up the viewable URL
     -------------------------------------------------------------------------*/
     $skip_it = 0;

     if ( !preg_match("/^<img src/i", $url['show']) ) $skip_it = 1;

     $url['show'] = preg_replace("/&amp;/", '&', $url['show']);
	 $url['show'] = preg_replace("/javascript:/i", 'javascript&#58; ', $url['show']);

	 if ( (strlen($url['show'])-58) < 3 ) $skip_it = 1;

	 // Make sure it's a "proper" url

	 if ( !preg_match("/^(http|ftp|https|news):\/\//i", $url['show']) ) $skip_it = 1;

	 $show = $url['show'];

	 if ( $skip_it != 1 ) {
		 $stripped = preg_replace("#^(http|ftp|https|news)://(\S+)$#i", "\\2", $url['show']);
		 $uri_type = preg_replace("#^(http|ftp|https|news)://(\S+)$#i", "\\1", $url['show']);

		 $show = $uri_type.'://'.substr($stripped, 0, 35).'...'.substr($stripped , -15);
	 }

	 return $url['st'].'<a href="'.$url['html'].'" target="_blank" class=ruskiy_link>'.$show.'</a>'.$url['end'];
 }


 //============================================
 // regex_preserve_spacing: keeps double spaces
 // without CSS killing <pre> tags
 //============================================
 function regex_preserve_spacing($txt='') {
	 $txt = preg_replace( "#\s{2}#", "&nbsp; ", trim($txt) );
	 return $txt;
 }

 /*===================================================
 // regex_check_flash: Checks, and builds the <object>
 // html.
 //====================================================

 function regex_check_flash($width="", $height="", $url="") {
		global $ibforums;

		$default = "\[flash=$width,$height\]$url\[/flash\]";

		if (!$ibforums->vars['allow_flash']) {
			return $default;
		}

		if ($width > $ibforums->vars['max_w_flash']) {
			$this->error = 'flash_too_big';
			return $default;
		}

		if ($height > $ibforums->vars['max_h_flash']) {
			$this->error = 'flash_too_big';
			return $default;
		}

		if (!preg_match( "/^http:\/\/(\S+)\.swf$/i", $url) ) {
			$this->error = 'flash_url';
			return $default;
		}

		return "<!--Flash $width+$height+$url--><OBJECT CLASSID='clsid:D27CDB6E-AE6D-11cf-96B8-444553540000' WIDTH=$width HEIGHT=$height><PARAM NAME=MOVIE VALUE=$url><PARAM NAME=PLAY VALUE=TRUE><PARAM NAME=LOOP VALUE=TRUE><PARAM NAME=QUALITY VALUE=HIGH><EMBED SRC=$url WIDTH=$width HEIGHT=$height PLAY=TRUE LOOP=TRUE QUALITY=HIGH></EMBED></OBJECT><!--End Flash-->";
 } */

 //======================================================
 // regex_check_image: Checks, and builds the <img>
 // html.
 //=======================================================
 function regex_check_image($url='') {

     if ( !$url ) return;

	 $url = trim($url);

	 //$default = '[img]'.$url.'[/img]';

	 // If we are still here....
	 $url = str_replace('', "%20", $url);

	 return '<img src="'.$url.'" border=0 />';
 }


 //==========================================
 // regex_font_attr:
 // Returns a string for an /e regexp based on the input
 //======================================================

 function regex_font_attr($code) {
	 if ( !is_array($code) ) return '';

	 // Trim out stoopid 1337 stuff
	 // [color=black;font-size:500pt;border:orange 50in solid;]hehe[/color]

	 if ( preg_match("/;/", $code['1']) )
		 $code['1'] = explode(';', $code['1']);


	 $code['1'] = preg_replace("/[&\(\)\.\%]/", "", $code['1']);

	 if ( $code['s'] == 'size' ) {
	 	 $code['1'] = $code['1'] + 7;

		 if ( $code['1'] > 30 )
			 $code['1'] = 30;

		 return '<span style="font-size:'.$IN['1'].'pt;line-height:100%">'.$IN['2'].'</span>';
     }
     else if ( $code['s'] == 'col' )
		 return '<span style="color:'.$code['1'].'">'.$code['2'].'</span>';

     else if ( $code['s'] == 'font' )
		 return '<span style="font-family:'.$code['1'].'">'.$code['2'].'</span>';

 }




}
?>