<?php /**************************************************************
*                  Ruskiy Guestbook 1.3 (Comment.php)               *
*  ---------------------------------------------------------------  *
*   Author:  Yarmoluk Ruslan                                        *
*   E-mail: ruslan@ruskiy.com.ru                                    *
*   Home page: http://www.ruskiy.com.ru                             *
*   Licence Info: http://www.ruskiy.com.ru/?license                 *
*   Date started: 3 September 2005                                  *
*   Module version: 1.0                                             *
*  ---------------------------------------------------------------  *
*                   (c) 2005 Yarmoluk Ruslan                        *
****************************************************** COMMENT ******/

$idx = new Modul;

class Modul {

  var $user = array(); // user data array
  var $html; // Template class


 /*=============================================================================
 | MAIN function (run automaticaly)
 =============================================================================*/
 function Modul() {
   global $Ruskiy, $functions, $cashe;

     $Ruskiy->Lang = $functions->load_words($Ruskiy->Lang, 'lang_comment');
     $this->html = $functions->load_template('tpl_comment');

     $Ruskiy->Lang['title'] = sprintf($Ruskiy->Lang['title'], $Ruskiy->GET['id']);
     $Ruskiy->CONF['mode'] = 'pop';

     switch ( $Ruskiy->GET['act'] ) {
       case '01':
           $this->showComments();
           break;

       case '02': // add comment
           $this->doAdd();
           break;

       default : // by default (show comments)
           $this->showComments();
           break;
    }

 }


 /*=============================================================================
 |    
 =============================================================================*/
 function Form($warning='') {
   global $Ruskiy, $cashe, $functions;

     $this->user = $functions->recollect_user();

     // if user is not login as member
     if ( !$this->user['password'] ) {

         // get user name from previous message or POST vars
         $this->user['name'] = empty($Ruskiy->POST['name']) ? $this->user['name'] : $Ruskiy->POST['name'];
         $cashe->set($this->html->name_input($this->user['name']), 'name');


         // is user have email and email is allow in guestbook
         if ( $Ruskiy->CONF['enable_email'] ) {

             /* if we allow to hide email
             if ( $Ruskiy->CONF['enable_hidemail'] ) {

                 $this->user['hidemail'] = empty($Ruskiy->POST['hidemail']) ? $this->user['hidemail'] : $Ruskiy->POST['hidemail'];
                 $cashe->set($this->html->hidemail($this->user['hidemail']), 'hidemail');
             } */

             $this->user['email'] = empty($Ruskiy->POST['email']) ? $this->user['email'] : $Ruskiy->POST['email'];
             $cashe->set($this->html->email_input($this->user['email']), 'email');
         }


     // user is login, so show only form title
     } else
         $Ruskiy->Lang['th_add'] = sprintf($Ruskiy->Lang['from_user'], $this->user['name']);


     //   
     if ( !empty($warning) )
         $cashe->set($this->html->warning($warning), 'warning');


     /*-------------------------------------------------------------------------
     |  
     -------------------------------------------------------------------------*/
     $cashe->add($this->html->form( array(
           'querry' => '?'.$Ruskiy->CONF['get_pre'].'mod=cmt&act=02&id='.$Ruskiy->GET['id'],
               'id' => '',
          'warning' => $cashe->pop('warning'),
             'name' => $cashe->pop('name'),
            'email' => $cashe->pop('email'),
         'hidemail' => $cashe->pop('hidemail'))
                                   ), 'body');


     $cashe->add($this->html->close_window(), 'body');

     if ( !empty($warning) )
         $functions->buid_page();


 }


 /*=============================================================================
 |     
 =============================================================================*/
 function doAdd() {
   global $Ruskiy, $functions, $cashe, $db;

     $user = $functions->recollect_user();

     if ( !$user['password'] ) {

         $this->user = array(
               'name' => $Ruskiy->POST['name'],
              'email' => $Ruskiy->CONF['enable_email'] ? $Ruskiy->POST['email'] : '',
           'hidemail' => $Ruskiy->CONF['enable_hidemail'] ? $Ruskiy->POST['hidemail'] : '',
                             );

         // is empty name?
         if ( empty($this->user['name']) ) {
             $this->Form($Ruskiy->Lang['empty_name']);

         // is long name?
         } elseif ( strlen($this->user['name']) > $Ruskiy->CONF['maxlen_name'] ) {
             $this->Form( sprintf($Ruskiy->Lang['long_name'], $Ruskiy->CONF['maxlen_name']) );

         // is long email?
         } elseif ( strlen($this->user['email']) > $Ruskiy->CONF['maxlen_email'] ) {
             $this->Form( sprintf($Ruskiy->Lang['long_email'], $Ruskiy->CONF['maxlen_email']) );

         // is wrong email?
         } elseif ( !empty($this->user['email']) && !eregi('^[a-z0-9_]+(([a-z0-9_.-]+)?)@[a-z0-9+](([a-z0-9_.-]+)?)+\.+[a-z]{2,4}$', $this->user['email']) ) {
             $this->Form($Ruskiy->Lang['wrong_email']);
         }


     } else {
         $this->user = array('uid' => $user['uid']);
     }


     // is empty message?
     if ( empty($Ruskiy->POST['text']) ) {
         $this->Form($Ruskiy->Lang['empty_message']);

     // is long message?
     } elseif ( strlen($Ruskiy->POST['text']) > $Ruskiy->CONF['maxlen_text'] ) {
         $this->Form( sprintf($Ruskiy->Lang['long_message'], $Ruskiy->CONF['maxlen_text']) );

     // is flood?
     } elseif ( $this->is_flood($Ruskiy->REMOTE_ADDR) ) {
         $this->Form( sprintf($Ruskiy->Lang['flood'], ($Ruskiy->CONF['flood_timer']/60)) );
     }


     // do parser functions (convert bbcodes to html ESSENCE) -<
     require ROOT_PATH. 'classes/class_parser.php';
     $parser = new Parser;

     // Remove danger chars
     $txt_clean = $parser->txt_getclean($Ruskiy->POST['text']);

     //  bcodes ([B],[I],[URL]...) if allowed bbcodes
     //$txt_clean = $parser->convert($txt_clean);
     // >- end parser


     $db_string = $db->implode_to_parts(
               array_merge($this->user, array(
                'mid' => $Ruskiy->GET['id'],
               'time' => $Ruskiy->TIME,
                 'ip' => $Ruskiy->REMOTE_ADDR,
               'text' => $txt_clean ))
                                        );

     $db->query('INSERT INTO rgb_comments (' .$db_string['NAMES']. ') VALUES (' .$db_string['VALUES']. ')' );


     // show redirect page
     $url_redirect = $Ruskiy->GuestUrl.'?'.$Ruskiy->CONF['get_pre'].'mod=cmt&id='.$Ruskiy->GET['id'];
     $functions->page_redirect($url_redirect, $Ruskiy->Lang['add_done']);

 }



 /*=============================================================================
 | show Comments
 =============================================================================*/
 function showComments() {
   global $Ruskiy, $functions, $cashe, $db;

     $squery = $db->query("SELECT * FROM rgb_comments WHERE mid=".$Ruskiy->GET['id']." ORDER BY time desc");

     //  ...
     while ( $record = $db->fetch_row($squery) ) {

        // if its user record, when take user data from members table
        if ( $record['uid'] ) {

            $db->query("SELECT name,email,hidemail FROM rgb_members WHERE uid=".$record['uid']);
            $record = array_merge($record, $db->fetch_row());
        }


        // is its private message?
        if ( $record['email'] ) {
            $cashe->set($this->html->email( $record['email'], $record['name'] ), 'name');

        } else {
            $cashe->set($record['name'], 'name');
        }


        // add record to cashe
        $cashe->add($this->html->record( array('id' => $record['cid'],
                      'name' => $cashe->pop('name'),
                      'text' => $record['text'],
                      'time' => $functions->n_date($record['time']),
                                        ) ), 'records');

     }

     $db->free_result($squery);


     //$cashe->set($this->html->close_window(), 'body');
     $cashe->add($this->html->comments( $cashe->pop('records') ), 'body');

     $this->Form();

     $functions->buid_page();

 }


 /*===========================
 | is its flood (time pause)
 ===========================*/
 function is_flood($ip) {
   global $db, $Ruskiy;

     if ( $Ruskiy->CONF['flood_timer'] != 0 ) {

         $time = $Ruskiy->TIME - $Ruskiy->CONF['flood_timer'];

         $db->query("SELECT cid FROM rgb_comments WHERE ip='$ip' and time>$time");

         if ( $data = $db->fetch_row() ) return TRUE;
         else return FALSE;

     } else return FALSE;

 }











}
?><?php require_once("include_options.php");?>